=== docs/requirements.txt ===
sphinx==7.3.7
readthedocs-sphinx-ext==2.1.9 # ??
sphinx-rtd-theme
myst-parser==3.0.1
