=== debian/changelog ===
opentimelineio (0.18.1-1fakesync1) resolute; urgency=medium

  * Fake sync due to mismatching orig tarball.

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 27 Nov 2025 12:25:49 -0500

opentimelineio (0.18.1-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patch 02-cmake-fixes.
  * Add missing files.
  * Adjust lintian overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 27 Nov 2025 10:36:59 +0100
